local MogIt,mog = ...;

--local IsModifiedClick = IsModifiedClick;
local IsShiftKeyDown = IsShiftKeyDown;
local IsControlKeyDown = IsControlKeyDown;
local GetItemInfo = GetItemInfo;
local GetCursorPosition = GetCursorPosition;
local GetMouseFocus = GetMouseFocus;
local GetScreenWidth = GetScreenWidth;
local GetScreenHeight = GetScreenHeight;
local type = type;
local pairs = pairs;
local ipairs = ipairs;
local tinsert = table.insert;
local tremove = table.remove;
local floor = math.floor;
local ceil = math.ceil;
local band = bit.band;
--local bor = bit.bor;

mog.models = {};
mog.bin = {};
mog.list = {};
mog.display = {};
mog.wl = {};

tinsert(UISpecialFrames,"MogItFrame");
mog.frame:Hide();
mog.frame:SetPoint("CENTER",UIParent,"CENTER");
mog.frame:SetWidth(220);
mog.frame:SetHeight(325);
mog.frame:SetFrameStrata("DIALOG");
mog.frame:SetFrameLevel(2);
mog.frame:SetClampedToScreen(true);
mog.frame:EnableMouse(true);
mog.frame:SetMovable(true);
mog.frame:SetUserPlaced(true);
mog.frame:SetScript("OnMouseDown",function(self) 
	self:StartMoving();
end);
mog.frame:SetScript("OnMouseUp",function(self) 
	self:StopMovingOrSizing();
end);
mog.frame.TitleText:SetText(MogIt);
mog.frame.portrait:SetTexture("Interface\\AddOns\\MogIt\\Images\\MogIt");
mog.frame.portrait:SetTexCoord(0,106/128,0,105/128);
mog.frame.wowhead = mog.frame:CreateTexture(nil,"ARTWORK");
mog.frame.wowhead:SetWidth(158);
mog.frame.wowhead:SetHeight(32);
mog.frame.wowhead:SetTexture("Interface\\AddOns\\MogIt\\Images\\Wowhead");
mog.frame.wowhead:SetTexCoord(0,158/256,0,1);
mog.frame.wowhead:SetPoint("TOPRIGHT",mog.frame,"TOPRIGHT",-6,-27);

mog.frame.expand = CreateFrame("Button",nil,mog.frame);
mog.frame.expand:SetWidth(27);
mog.frame.expand:SetHeight(27);
mog.frame.expand:SetPoint("TOPRIGHT",mog.frame.Inset,"BOTTOMRIGHT",1,2);
mog.frame.expand:SetScript("OnClick",function(self)
	if mog.grid:IsShown() then
		mog.grid:Hide();
	else
		mog.grid:Show();
	end
end);
mog.frame.expand:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up");
mog.frame.expand:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down");
mog.frame.expand:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled");
mog.frame.expand:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight","ADD");

mog.frame.tab1 = CreateFrame("Button","MogItFrameTab1",mog.frame,"CharacterFrameTabButtonTemplate");
mog.frame.tab1:SetPoint("TOPLEFT",mog.frame,"BOTTOMLEFT",1,2);
mog.frame.tab1:SetText("Controls");
mog.frame.tab1:SetID(1);
mog.frame.tab1:SetScript("OnLoad",nil);
mog.frame.tab1:SetScript("OnEvent",nil);
mog.frame.tab1:SetScript("OnEnter",nil);
mog.frame.tab1:SetScript("OnLeave",nil);
mog.frame.tab1:SetScript("OnShow",function(self)
	PanelTemplates_TabResize(self, 0, nil, 36, 88);
end);
mog.frame.tab1:SetScript("OnClick",function(self)
	PanelTemplates_Tab_OnClick(self, mog.frame);
	mog.manip:Show();
	mog.filt:Hide();
	mog.optscroll:Hide();
end);
mog.frame.tab2 = CreateFrame("Button","MogItFrameTab2",mog.frame,"CharacterFrameTabButtonTemplate");
mog.frame.tab2:SetPoint("LEFT",mog.frame.tab1,"RIGHT",-15,0);
mog.frame.tab2:SetText("Filters");
mog.frame.tab2:SetID(2);
mog.frame.tab2:SetScript("OnLoad",nil);
mog.frame.tab2:SetScript("OnEvent",nil);
mog.frame.tab2:SetScript("OnEnter",nil);
mog.frame.tab2:SetScript("OnLeave",nil);
mog.frame.tab2:SetScript("OnShow",function(self)
	PanelTemplates_TabResize(self, 0, nil, 36, 88);
end);
mog.frame.tab2:SetScript("OnClick",function(self)
	PanelTemplates_Tab_OnClick(self, mog.frame);
	mog.manip:Hide();
	mog.filt:Show();
	mog.optscroll:Hide();
end);
mog.frame.tab3 = CreateFrame("Button","MogItFrameTab3",mog.frame,"CharacterFrameTabButtonTemplate");
mog.frame.tab3:SetPoint("LEFT",mog.frame.tab2,"RIGHT",-15,0);
mog.frame.tab3:SetText("Options");
mog.frame.tab3:SetID(3);
mog.frame.tab3:SetScript("OnLoad",nil);
mog.frame.tab3:SetScript("OnEvent",nil);
mog.frame.tab3:SetScript("OnEnter",nil);
mog.frame.tab3:SetScript("OnLeave",nil);
mog.frame.tab3:SetScript("OnShow",function(self)
	PanelTemplates_TabResize(self, 0, nil, 36, 88);
end);
mog.frame.tab3:SetScript("OnClick",function(self)
	PanelTemplates_Tab_OnClick(self, mog.frame);
	mog.manip:Hide();
	mog.filt:Hide();
	mog.optscroll:Show();
end);
PanelTemplates_SetNumTabs(mog.frame, 3);
PanelTemplates_SetTab(mog.frame, 1);

mog.grid = MogItGrid;
mog.grid:Hide();
mog.grid:SetPoint("TOPLEFT",mog.frame,"TOPRIGHT",10,-10);
mog.grid:EnableMouse(true);
mog.grid:SetResizable(true);
mog.grid:SetClampedToScreen(true);
mog.grid:SetFrameStrata("HIGH");
mog.grid:SetFrameLevel(1);
mog.grid:SetPoint("CENTER");
mog.grid:SetHitRectInsets(-10,-10,-10,-10);
mog.grid:SetScript("OnShow",function(self)
	mog.scroll:update();
	mog.frame.expand:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up");
	mog.frame.expand:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down");
	mog.frame.expand:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled");
end);
mog.grid:SetScript("OnHide",function(self)
	mog.frame.expand:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up");
	mog.frame.expand:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down");
	mog.frame.expand:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled");
end);

mog.grid.resize = CreateFrame("Frame",nil,mog.grid);
mog.grid.resize:SetWidth(28);
mog.grid.resize:SetHeight(28);
mog.grid.resize:SetPoint("BOTTOMRIGHT",mog.grid,"BOTTOMRIGHT",10,-10);
mog.grid.resize:EnableMouse(true);
mog.grid.resize:SetScript("OnMouseDown",function(self)
	if GameTooltip:GetOwner() == self then
		GameTooltip:Hide();
	end
	mog.grid:SetMinResize(mog.settings.columns*5 + ((mog.settings.columns-1) * 5) + 20 + 43,mog.settings.rows*5 + ((mog.settings.rows-1) * 5) + 20 + 20);
	mog.grid:SetMaxResize(GetScreenWidth()-230,GetScreenHeight());
	mog.grid:StartSizing();
	mog.grid.resize.update:Show();
end);
mog.grid.resize:SetScript("OnMouseUp",function(self)
	mog.grid.resize.update:Hide();
	mog.grid:StopMovingOrSizing();
	if GetMouseFocus() == self then
		GameTooltip:SetOwner(self,"ANCHOR_RIGHT",0,0);
		GameTooltip:AddLine("MogIt");
		GameTooltip:AddLine("Click and drag this corner to resize the MogIt frame.",1,1,1);
		GameTooltip:Show();
	end
	mog.settings.guiWidth = floor((mog.grid:GetWidth() - (((mog.settings.columns-1) * 5) + 20 + 43))/mog.settings.columns);
	mog.settings.guiHeight = floor((mog.grid:GetHeight() - (((mog.settings.rows-1) * 5) + 20 + 20))/mog.settings.rows);
	mog.grid:ClearAllPoints();
	mog.grid:SetPoint("TOPLEFT",mog.frame,"TOPRIGHT",10,-10);
	mog.updateGUI(true);
end);
mog.grid.resize:SetScript("OnEnter",function(self)
	GameTooltip:SetOwner(self,"ANCHOR_RIGHT",0,0);
	GameTooltip:AddLine("MogIt");
	GameTooltip:AddLine("Click and drag this corner to resize the MogIt frame.",1,1,1);
	GameTooltip:Show();
end);
mog.grid.resize:SetScript("OnLeave",function(self)
	if GameTooltip:GetOwner() == self then
		GameTooltip:Hide();
	end
end);
mog.grid.resize.update = CreateFrame("Frame",nil,mog.grid.resize);
mog.grid.resize.update:Hide();
mog.grid.resize.update:SetScript("OnUpdate",function(self)
	mog.settings.guiWidth = floor((mog.grid:GetWidth() - (((mog.settings.columns-1) * 5) + 20 + 43))/mog.settings.columns);
	mog.settings.guiHeight = floor((mog.grid:GetHeight() - (((mog.settings.rows-1) * 5) + 20 + 20))/mog.settings.rows);
	mog.grid:ClearAllPoints();
	mog.grid:SetPoint("TOPLEFT",mog.frame,"TOPRIGHT",10,-10);
	mog.updateGUI(true);
end);
mog.grid.resize.texture = mog.grid.resize:CreateTexture(nil,"OVERLAY");
mog.grid.resize.texture:SetWidth(16);
mog.grid.resize.texture:SetHeight(16);
mog.grid.resize.texture:SetTexture("Interface\\AddOns\\MogIt\\Images\\Resize");
mog.grid.resize.texture:SetPoint("BOTTOMRIGHT",mog.grid.resize,"BOTTOMRIGHT",-3,3);

function mog.addModel()
	local f;
	if mog.bin[1] then
		f = mog.bin[1];
		tremove(mog.bin,1);
	else
		f = CreateFrame("DressUpModel",nil,mog.grid);
		f:Hide();
		f:SetBackdrop({
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
			--edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 16, --edgeSize = 16, 
			insets = { left = 0, right = 0, top = 0, bottom = 0 }
		});
		f:SetBackdropColor(0,0,0,0.5);
		f:SetUnit("PLAYER");
		f:SetModelScale(2);
		f:EnableMouse(true);
		f:SetScript("OnMouseUp",function(self,btn)
			if GetMouseFocus() == self then
				if btn == "LeftButton" then
					if IsShiftKeyDown() then
						local _,link = GetItemInfo(self.item);
						if link then
							ChatEdit_InsertLink(link);
						end
					elseif IsControlKeyDown() then
						DressUpItemLink(self.item);
					else
						StaticPopup_Show("MOGIT_WOWHEADITEM",nil,nil,mog.display[mog.filters.display[self.item]]);
					end
				elseif btn == "RightButton" then
					if IsControlKeyDown() then
						mog.manip.model:TryOn(self.item);
					else
						if mog.selected == "wl" then
							mog.wishlist.item[mog.wl[self.item]] = nil;
							mog.wishlist.display[mog.wl[self.item]] = nil;
							mog.wishlist.time[mog.wl[self.item]] = nil;
							table.remove(mog.list,self.index);
							mog.display[mog.wl[self.item]] = nil;
							mog.wl[self.item] = nil;
							mog.scroll:update();
						else
							mog.wishlist.item[mog.filters.display[self.item]] = self.item;
							mog.wishlist.display[mog.filters.display[self.item]] = mog.display[mog.filters.display[self.item]];
							mog.wishlist.time[mog.filters.display[self.item]] = time();
						end
					end
				end
			end
		end);
		f:SetScript("OnEnter",mog.updateTooltip);
		f:SetScript("OnLeave",function(self)
			mog.over = nil;
			if GameTooltip:GetOwner() == self then
				GameTooltip:Hide();
			end
		end);
		f:SetScript("OnHide",function(self)
			self:SetPosition(0,0,0);
		end);
		f:SetScript("OnShow",function(self)
			self:SetPosition(mog.manip.posZ,mog.manip.posX,mog.manip.posY);
		end);
	end
	tinsert(mog.models,f);
end

function mog.delModel(f)
	if mog.models[f] then
		mog.models[f]:Hide();
		tinsert(mog.bin,mog.models[f]);
		tremove(mog.models,f);
	end
end

function mog.updateGUI(resize)
	local rows = (mog.settings.rows and mog.settings.rows > 0 and mog.settings.rows or 1);
	local columns = (mog.settings.columns and mog.settings.columns > 0 and mog.settings.columns or 1);
	local total = rows*columns;
	local current = #mog.models;
	local width = (mog.settings.guiWidth and mog.settings.guiWidth > 5 and mog.settings.guiWidth or 5);
	local height = (mog.settings.guiHeight and mog.settings.guiHeight > 5 and mog.settings.guiHeight or 5);
	
	if resize then
		--FauxScrollFrame_OnVerticalScroll(mog.scroll,0,mog.settings.guiHeight,mog.scroll.update);
		FauxScrollFrame_OnVerticalScroll(mog.scroll,0,mog.settings.guiHeight);
		--FauxScrollFrame_Update(mog.scroll,ceil(#mog.list/total),1,mog.settings.guiHeight);
	else
		if current > total then
			for i=current,(total+1),-1 do
				mog.delModel(i);
			end
		elseif current < total then
			for i=(current+1),total,1 do
				mog.addModel();
			end
		end
		
		mog.grid:SetWidth((columns * width) + ((columns-1) * 5) + 20 + 43);
		mog.grid:SetHeight((rows * height) + ((rows-1) * 5) + 20 + 20);
	end
	
	for row=1,rows do
		for column=1,columns do
			local n = ((row-1)*columns)+column;
			if n==1 then
				mog.models[n]:SetPoint("TOPLEFT",mog.grid,"TOPLEFT",20,-20);
			elseif column==1 then
				mog.models[n]:SetPoint("TOPLEFT",mog.models[n-columns],"BOTTOMLEFT",0,-5);
			else
				mog.models[n]:SetPoint("TOPLEFT",mog.models[n-1],"TOPRIGHT",5,0);
			end
			mog.models[n]:SetWidth(width);
			mog.models[n]:SetHeight(height);
		end
	end
end

mog.scroll = CreateFrame("ScrollFrame","MogItScroll",mog.grid,"FauxScrollFrameTemplate");
mog.scroll:SetPoint("TOPLEFT",mog.grid,"TOPLEFT",20,-20);
mog.scroll:SetPoint("BOTTOMRIGHT",mog.grid,"BOTTOMRIGHT",-43,20);
mog.scroll:SetHitRectInsets(-30,-52,-30,-30);
mog.scroll.ScrollBar:SetBackdrop({
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
	--edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true, tileSize = 16, --edgeSize = 16, 
	insets = { left = 0, right = 0, top = 0, bottom = 0 }
});
mog.scroll.ScrollBar:SetBackdropColor(0,0,0,0.5);


function mog.scroll.update(self)
	local offset = FauxScrollFrame_GetOffset(self);
	local models = #mog.models;
	local model,item;
	FauxScrollFrame_Update(self,ceil(#mog.list/models),1,mog.settings.guiHeight);
	for model=1,models do
		item = (offset*models)+model;
		if mog.list[item] then
			mog.models[model]:Show();
			if mog.settings.guiDress then
				mog.models[model]:Dress();
			else
				mog.models[model]:Undress();
			end
			mog.models[model]:TryOn(mog.list[item]);
			mog.models[model].item = mog.list[item];
			mog.models[model].index = item;
		else
			mog.models[model]:Hide();
		end
	end
	if mog.over and GameTooltip:GetOwner() == mog.over then
		mog.updateTooltip(mog.over);
	end
end

mog.scroll:SetScript("OnVerticalScroll",function(self,offset)
	FauxScrollFrame_OnVerticalScroll(self,offset,mog.settings.guiHeight,mog.scroll.update);
end);

function mog.buildList()
	if not mog.selected then return end;
	wipe(mog.list);
	wipe(mog.display);
	if mog.selected == "wl" then
		wipe(mog.wl);
		for k,v in pairs(mog.wishlist.item) do
			table.insert(mog.list,v);
			mog.display[k] = mog.wishlist.display[k];
			mog.wl[v] = k;
		end
		table.sort(mog.list,function(a,b)
			if mog.wishlist.time[mog.wl[a]] == mog.wishlist.time[mog.wl[b]] then
				return a > b;
			else
				return mog.wishlist.time[mog.wl[a]] > mog.wishlist.time[mog.wl[b]];
			end
		end);
	else
		for k,v in ipairs(mog.db[mog.selected]) do
			if mog.filterLevel(v) and mog.filterFaction(v) and mog.filterClass(v) then
				local disp = mog.filters.display[v];
				if not mog.display[disp] then
					mog.display[disp] = v;
					tinsert(mog.list,v);
				elseif type(mog.display[disp]) == "table" then
					tinsert(mog.display[disp],v);
				else
					mog.display[disp] = {mog.display[disp],v};
				end
			end
		end
		table.sort(mog.list,function(a,b)
			if mog.filters.lvl[a] == mog.filters.lvl[b] then
				return a > b;
			else
				return mog.filters.lvl[a] > mog.filters.lvl[b];
			end
		end);
	end
	if mog.grid:IsShown() then
		FauxScrollFrame_OnVerticalScroll(mog.scroll,0,mog.settings.guiHeight,mog.scroll.update);
	else
		FauxScrollFrame_OnVerticalScroll(mog.scroll,0,mog.settings.guiHeight);
		mog.grid:Show();
	end
	mog.filt.items:SetText(#mog.list);
end

function mog.filterLevel(v)
	return (mog.filters.lvl[v] >= mog.filt._minlvl) and (mog.filters.lvl[v] <= mog.filt._maxlvl);
end

function mog.filterFaction(v)
	return (not mog.filt._faction) or (not mog.filters.faction[v]) or (mog.filters.faction[v] == mog.filt._faction);
end

function mog.filterClass(v)
	return (not mog.filters.class[v]) or (band(mog.filters.class[v],mog.filt._class) > 0); 
end

StaticPopupDialogs["MOGIT_WOWHEADITEM"] = {
	text = "Wowhead Item URL",
	button1 = CLOSE,
	hasEditBox = 1,
	maxLetters = 150,
	editBoxWidth = 260,
	OnShow = function(self,item)
		local url;
		if type(item) == "table" then
			url = "http://www.wowhead.com/compare?items=";
			for k,v in ipairs(item) do
				url = url..v..";";
			end
		else
			url = "http://www.wowhead.com/item="..item;
		end
		self.editBox:SetText(url);
		self.editBox:SetFocus();
		self.editBox:HighlightText();
	end,
	EditBoxOnEnterPressed = function(self)
		self:GetParent():Hide();
	end,
	EditBoxOnEscapePressed = function(self)
		self:GetParent():Hide();
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	hideOnEscape = 1
};

function mog.updateTooltip(self)
	mog.over = self;
	GameTooltip:SetOwner(self,"ANCHOR_RIGHT",0,0);
	GameTooltip:AddLine("MogIt");
	GameTooltip:AddLine(" ");
	GameTooltip:AddLine("Controls");
	GameTooltip:AddDoubleLine("Scroll through list","Scroll wheel",0,1,0,1,1,1);
	GameTooltip:AddDoubleLine("Wowhead URL","Left click",0,1,0,1,1,1);
	GameTooltip:AddDoubleLine("Chat link","Shift + Left click",0,1,0,1,1,1);
	GameTooltip:AddDoubleLine("Try on","Ctrl + Left click",0,1,0,1,1,1);
	GameTooltip:AddDoubleLine((mog.selected == "wl" and "Delete from" or "Add to").." wishlist","Right click",0,1,0,1,1,1);
	GameTooltip:AddDoubleLine("Add to control model","Ctrl + Right click",0,1,0,1,1,1);
	GameTooltip:AddLine(" ");
	GameTooltip:AddLine("Items");
	local disp = (mog.selected == "wl" and mog.display[mog.wl[self.item]]) or mog.display[mog.filters.display[self.item]];
	if type(disp) == "table" then
		for k,v in ipairs(disp) do
			local name,link,_,_,_,_,_,_,_,texture = GetItemInfo(v);
			GameTooltip:AddDoubleLine((link or ("["..(name or "Unknown").."]")),"ID: "..v,1,0,0,1,1,1);
			GameTooltip:AddTexture(texture or "");
		end
	else
		local name,link,_,_,_,_,_,_,_,texture = GetItemInfo(disp);
		GameTooltip:AddDoubleLine((link or ("["..(name or "Unknown").."]")),"ID: "..disp,1,0,0,1,1,1);
		GameTooltip:AddTexture(texture);
	end
	GameTooltip:Show();
end

mog.manip = CreateFrame("Frame",nil,mog.frame);
mog.manip:SetAllPoints(mog.frame.Inset);

mog.dd = CreateFrame("Frame","MogItFrameDropdown",mog.manip,"UIDropDownMenuTemplate");
mog.dd:SetPoint("TOP",mog.manip,"TOP",0,-6);
UIDropDownMenu_SetWidth(mog.dd,180);
UIDropDownMenu_SetButtonWidth(mog.dd,195);
UIDropDownMenu_JustifyText(mog.dd,"LEFT");
UIDropDownMenu_SetText(mog.dd,"Select a category");
function mog.dd:initialize(tier)
	if tier == 1 then
		local info = UIDropDownMenu_CreateInfo();
		info.text = "\124cFFFFFF00Wishlist\124r";
		info.value = "wl";
		info.notCheckable = true;
		info.func = function(self)
			UIDropDownMenu_SetText(mog.dd,"Wishlist");
			mog.selected = self.value;
			mog.buildList();
		end
		UIDropDownMenu_AddButton(info,tier);
		for k,v in pairs(mog.addons) do
			local info = UIDropDownMenu_CreateInfo();
			info.text = "\124cFF"..(v and "00FF00" or "FF0000")..k.."\124r"..(v and "" or " (Click to load addon)");
			info.value = k;
			info.hasArrow = v and true;
			info.keepShownOnClick = v and true;
			info.notCheckable = true;
			info.func = function(self)
				if not mog.addons[self.value] then
					LoadAddOn("MogIt_"..self.value);
				end
			end
			UIDropDownMenu_AddButton(info,tier);
		end
	elseif tier == 2 then
		for k,v in ipairs(mog.addons[UIDROPDOWNMENU_MENU_VALUE]) do
			local info = UIDropDownMenu_CreateInfo();
			info.text = mog.labels[v];
			info.value = v;
			info.notCheckable = true;
			info.func = function(self)
				UIDropDownMenu_SetText(mog.dd,self.arg1.." - "..mog.labels[self.value]);
				mog.selected = self.value;
				mog.buildList();
				CloseDropDownMenus();
			end
			info.arg1 = UIDROPDOWNMENU_MENU_VALUE;
			UIDropDownMenu_AddButton(info,tier);
		end
	end
end

mog.manip.model = CreateFrame("DressUpModel",nil,mog.manip);
mog.manip.model:SetWidth(195);
mog.manip.model:SetHeight(195);
mog.manip.model:SetPoint("TOP",mog.manip,"TOP",0,-37);
mog.manip.model:SetBackdrop({
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", 
	--edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true, tileSize = 16, --edgeSize = 16, 
	insets = {left = 0, right = 0, top = 0, bottom = 0},
});
mog.manip.model:SetBackdropColor(71/255,95/255,121/255,1);
mog.manip.model:EnableMouse(true);
mog.manip.model:EnableMouseWheel(true);
mog.manip.model:SetModelScale(2);
mog.manip.model:SetScript("OnEnter",function(self)
	GameTooltip:SetOwner(self,"ANCHOR_RIGHT",0,0);
	GameTooltip:AddLine("MogIt");
	GameTooltip:AddLine(" ");
	GameTooltip:AddLine("Controls");
	GameTooltip:AddDoubleLine("Rotate","Left click + drag",0,1,0,1,1,1);
	GameTooltip:AddDoubleLine("Move","Right click + drag",0,1,0,1,1,1);
	GameTooltip:AddDoubleLine("Zoom","Scroll wheel",0,1,0,1,1,1);
	GameTooltip:Show();
end);
mog.manip.model:SetScript("OnLeave",function(self)
	if GameTooltip:GetOwner() == self then
		GameTooltip:Hide();
	end
end);

mog.manip.posX = 0;
mog.manip.posY = 0;
mog.manip.posZ = 0;
mog.manip.face = 0;

function mog.manip.mass(rotate,pose)
	if rotate then
		mog.manip.model:SetFacing(mog.manip.face);
		for k,v in ipairs(mog.models) do
			v:SetFacing(mog.manip.face);
		end
	end
	if pose then
		mog.manip.model:SetPosition(mog.manip.posZ,mog.manip.posX,mog.manip.posY);
		if mog.grid:IsShown() then
			for k,v in ipairs(mog.models) do
				v:SetPosition(mog.manip.posZ,mog.manip.posX,mog.manip.posY);
			end
		end
	end
end

mog.manip.update = CreateFrame("Frame",mog.manip);
mog.manip.update:SetScript("OnUpdate",function(self)
	local currentx,currenty = GetCursorPosition();
	if self.isRotating then
		mog.manip.face = mog.manip.face + ((currentx-self.prevx)/50);
		mog.manip.mass(true);
	elseif self.isPosing then
		mog.manip.posX = mog.manip.posX + ((currentx-self.prevx)/50);
		mog.manip.posY = mog.manip.posY + ((currenty-self.prevy)/50);
		mog.manip.mass(nil,true);
	end
	self.prevx,self.prevy = currentx,currenty;
end);
mog.manip.model:SetScript("OnMouseDown",function(self,btn)
	if btn == "LeftButton" then
		mog.manip.update.isRotating = 1;
	elseif btn == "RightButton" then
		mog.manip.update.isPosing = 1;
	end
	mog.manip.update.prevx,mog.manip.update.prevy = GetCursorPosition();
	mog.manip.update:Show();
end);
mog.manip.model:SetScript("OnMouseUp",function(self,btn)
	mog.manip.update:Hide();
	local currentx,currenty = GetCursorPosition();
	if mog.manip.update.isRotating then
		mog.manip.face = mog.manip.face + ((currentx-mog.manip.update.prevx)/50);
		mog.manip.mass(true);
	elseif mog.manip.update.isPosing then
		mog.manip.posX = mog.manip.posX + ((currentx-mog.manip.update.prevx)/50);
		mog.manip.posY = mog.manip.posY + ((currenty-mog.manip.update.prevy)/50);
		mog.manip.mass(nil,true);
	end
	mog.manip.update.isRotating = nil;
	mog.manip.update.isPosing = nil;
end);
mog.manip.model:SetScript("OnMouseWheel",function(self,v)
	mog.manip.posZ = mog.manip.posZ + ((v > 0 and 0.6) or -0.6);
	mog.manip.mass(nil,true);
end);

mog.manip.reset = CreateFrame("Button",nil,mog.manip,"UIPanelButtonTemplate");
mog.manip.reset:SetText(RESET);
mog.manip.reset:SetWidth(65);
mog.manip.reset:SetHeight(22);
mog.manip.reset:SetPoint("TOPLEFT",mog.frame.Inset,"BOTTOMLEFT");
mog.manip.reset:SetScript("OnClick",function(self,btn)
	mog.manip.posX = 0;
	mog.manip.posY = 0;
	mog.manip.posZ = 0;
	mog.manip.face = 0;
	mog.manip.mass(true,true);
end);

mog.manip.model:SetScript("OnHide",function(self)
	self:SetPosition(0,0,0);
end);
mog.manip.model:SetScript("OnShow",function(self)
	self:SetPosition(mog.manip.posZ,mog.manip.posX,mog.manip.posY);
end);

mog.manip.zoomIn = CreateFrame("Button","MogItControlZoomIn",mog.manip,"UIPanelButtonTemplate2");
mog.manip.zoomIn:SetText("+");
mog.manip.zoomIn:SetWidth(22);
mog.manip.zoomIn:SetHeight(22);
mog.manip.zoomIn:SetPoint("TOPLEFT",mog.manip.reset,"TOPRIGHT",0,0);
mog.manip.zoomIn:SetScript("OnMouseDown",function(self)
	mog.manip.zoom.dir = true;
	mog.manip.zoom:Show();
end);
mog.manip.zoomIn:SetScript("OnMouseUp",function(self)
	mog.manip.zoom:Hide();
end);
mog.manip.zoomOut = CreateFrame("Button","MogItControlZoomOut",mog.manip,"UIPanelButtonTemplate2");
mog.manip.zoomOut:SetText("-");
mog.manip.zoomOut:SetWidth(22);
mog.manip.zoomOut:SetHeight(22);
mog.manip.zoomOut:SetPoint("TOPLEFT",mog.manip.zoomIn,"TOPRIGHT",0,0);
mog.manip.zoomOut:SetScript("OnMouseDown",function(self)
	mog.manip.zoom.dir = false;
	mog.manip.zoom:Show();
end);
mog.manip.zoomOut:SetScript("OnMouseUp",function(self)
	mog.manip.zoom:Hide();
end);
mog.manip.zoom = CreateFrame("Frame",nil,mog.manip);
mog.manip.zoom:Hide();
mog.manip.zoom:SetScript("OnUpdate",function(self,elapsed)
	if self.dir then
		mog.manip.posZ = mog.manip.posZ + elapsed*3;
	else
		mog.manip.posZ = mog.manip.posZ - elapsed*3;
	end
	mog.manip.mass(nil,true);
end);

mog.filt = CreateFrame("Frame",nil,mog.frame);
mog.filt:Hide();

mog.filt._minlvl = 0;
mog.filt._maxlvl = UnitLevel("PLAYER");
mog.filt._faction = UnitFactionGroup("PLAYER") == "Alliance" and 1 or 2;
mog.filt._class = {};

mog.filt:SetAllPoints(mog.frame.Inset);
mog.filt.lvl = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.lvl:SetPoint("TOPLEFT",mog.filt,"TOPLEFT",15,-15);
mog.filt.lvl:SetText(LEVEL_RANGE..":");
mog.filt.minlvl = CreateFrame("EditBox","MogItFrameMinLvl",mog.filt,"InputBoxTemplate");
mog.filt.minlvl:SetSize(25,16);
mog.filt.minlvl:SetPoint("TOPLEFT",mog.filt,"TOP",0,-15);
mog.filt.minlvl:SetNumeric(true);
mog.filt.minlvl:SetMaxLetters(2);
mog.filt.minlvl:SetNumber(mog.filt._minlvl);
mog.filt.minlvl:SetAutoFocus(false);
mog.filt.minlvl:SetScript("OnEnterPressed",EditBox_ClearFocus);
mog.filt.minlvl:SetScript("OnTabPressed",function(self)
	mog.filt.maxlvl:SetFocus();
end);
mog.filt.lvlh = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.lvlh:SetPoint("LEFT",mog.filt.minlvl,"RIGHT",0,1);
mog.filt.lvlh:SetText("-");
mog.filt.maxlvl = CreateFrame("EditBox","MogItFrameMaxLvl",mog.filt,"InputBoxTemplate");
mog.filt.maxlvl:SetSize(25,16);
mog.filt.maxlvl:SetPoint("LEFT",mog.filt.minlvl,"RIGHT",12,0);
mog.filt.maxlvl:SetNumeric(true);
mog.filt.maxlvl:SetMaxLetters(2);
mog.filt.maxlvl:SetNumber(mog.filt._maxlvl);
mog.filt.maxlvl:SetAutoFocus(false);
mog.filt.maxlvl:SetScript("OnEnterPressed",EditBox_ClearFocus);
mog.filt.maxlvl:SetScript("OnTabPressed",function(self)
	mog.filt.minlvl:SetFocus();
end);

mog.filt.faction = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.faction:SetPoint("TOPLEFT",mog.filt.lvl,"BOTTOMLEFT",0,-18);
mog.filt.faction:SetText(FACTION..":");

mog.filt.factionAll = CreateFrame("CheckButton","MogItFrameFactionAll",mog.filt,"UIRadioButtonTemplate");
MogItFrameFactionAllText:SetText(ALL);
mog.filt.factionAll:SetPoint("TOPLEFT",mog.filt.minlvl,"BOTTOMLEFT",-7,-13);
mog.filt.factionAll:SetChecked(false);
mog.filt.factionAll:SetScript("OnClick",function(self)
	self:SetChecked(true);
	mog.filt.factionAlliance:SetChecked(false);
	mog.filt.factionHorde:SetChecked(false);
end);

mog.filt.factionAlliance = CreateFrame("CheckButton","MogItFrameFactionAlliance",mog.filt,"UIRadioButtonTemplate");
MogItFrameFactionAllianceText:SetText("Alliance");
mog.filt.factionAlliance:SetPoint("TOPLEFT",mog.filt.factionAll,"BOTTOMLEFT",0,-5);
mog.filt.factionAlliance:SetChecked(mog.filt._faction == 1);
mog.filt.factionAlliance:SetScript("OnClick",function(self)
	self:SetChecked(true);
	mog.filt.factionAll:SetChecked(false);
	mog.filt.factionHorde:SetChecked(false);
end);

mog.filt.factionHorde = CreateFrame("CheckButton","MogItFrameFactionHorde",mog.filt,"UIRadioButtonTemplate");
MogItFrameFactionHordeText:SetText("Horde");
mog.filt.factionHorde:SetPoint("TOPLEFT",mog.filt.factionAlliance,"BOTTOMLEFT",0,-5);
mog.filt.factionHorde:SetChecked(mog.filt._faction == 2);
mog.filt.factionHorde:SetScript("OnClick",function(self)
	self:SetChecked(true);
	mog.filt.factionAll:SetChecked(false);
	mog.filt.factionAlliance:SetChecked(false);
end);

mog.filt.class = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.class:SetPoint("TOPLEFT",mog.filt.faction,"BOTTOMLEFT",0,-65);
mog.filt.class:SetText("Class Items:");

local classCoords = CLASS_ICON_TCOORDS;
local classColours = RAID_CLASS_COLORS;
local classes = {};
FillLocalizedClassList(classes,UnitSex("PLAYER")==3);
local classBits = {
	DEATHKNIGHT = 32,
	DRUID = 1024,
	HUNTER = 4,
	MAGE = 128,
	PALADIN = 2,
	PRIEST = 16,
	ROGUE = 8,
	SHAMAN = 64,
	WARLOCK = 256,
	WARRIOR = 1,
};
local classSelected = {[select(2,UnitClass("PLAYER"))] = true};
mog.filt._class = classBits[select(2,UnitClass("PLAYER"))];

mog.filt.dd = CreateFrame("Frame","MogItFrameClassDropdown",mog.filt,"UIDropDownMenuTemplate");
mog.filt.dd:SetPoint("TOPLEFT",mog.filt.factionHorde,"BOTTOMLEFT",-18,-10);
UIDropDownMenu_SetWidth(mog.filt.dd,88);
UIDropDownMenu_SetButtonWidth(mog.filt.dd,103);
UIDropDownMenu_JustifyText(mog.filt.dd,"LEFT");
UIDropDownMenu_SetText(mog.filt.dd,"Select");
function mog.filt.dd:initialize()
	for k,v in pairs(classes) do
		local info = UIDropDownMenu_CreateInfo();
		info.text =	string.format("\124cff%.2x%.2x%.2x",classColours[k].r*255,classColours[k].g*255,classColours[k].b*255)..classes[k].."\124r";
		info.value = k;
		info.func = function(self)
			classSelected[self.value] = self.checked;
		end
		info.keepShownOnClick = true;
		info.isNotRadio = true;
		info.checked = classSelected[k];
		info.icon = "Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes";
		info.tCoordLeft = classCoords[k][1];
		info.tCoordRight = classCoords[k][2];
		info.tCoordTop = classCoords[k][3];
		info.tCoordBottom = classCoords[k][4];
		UIDropDownMenu_AddButton(info);
	end
end

mog.filt.total = mog.filt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.filt.total:SetPoint("BOTTOMLEFT",mog.filt,"BOTTOMLEFT",15,15);
mog.filt.total:SetText("Total Models:");

mog.filt.items = mog.filt:CreateFontString(nil,"ARTWORK","GameFontNormalSmall");
mog.filt.items:SetPoint("BOTTOMLEFT",mog.filt,"BOTTOM",0,15);
mog.filt.items:SetText("0");

mog.filt.apply = CreateFrame("Button",nil,mog.filt,"UIPanelButtonTemplate");
mog.filt.apply:SetText(APPLY);
mog.filt.apply:SetWidth(65);
mog.filt.apply:SetHeight(22);
mog.filt.apply:SetPoint("TOPLEFT",mog.frame.Inset,"BOTTOMLEFT");
mog.filt.apply:SetScript("OnClick",function(self,btn)
	mog.filt._minlvl = mog.filt.minlvl:GetNumber();
	mog.filt._maxlvl = mog.filt.maxlvl:GetNumber();
	mog.filt._faction = (mog.filt.factionAlliance:GetChecked() and 1) or (mog.filt.factionHorde:GetChecked() and 2);
	mog.filt._class = 0;
	for k,v in pairs(classSelected) do
		if v then
			mog.filt._class = mog.filt._class + classBits[k];
		end
	end
	mog.buildList();
end);

mog.optscroll = CreateFrame("ScrollFrame","MogItFrameOptScroll",mog.frame,"UIPanelScrollFrameTemplate");
mog.optscroll:Hide();
mog.optscroll:SetPoint("TOPLEFT",mog.frame.Inset,"TOPLEFT",5,-4);
mog.optscroll:SetPoint("BOTTOMRIGHT",mog.frame.Inset,"BOTTOMRIGHT",-26,2);
mog.opt = CreateFrame("Frame","MogItFrameOptions",mog.optscroll);
mog.opt:SetWidth(180);
mog.opt:SetHeight(350);
mog.optscroll:SetScrollChild(mog.opt);
mog.optscroll:SetScript("OnShow",function(self)
	mog.opt.update();
end);

mog.opt.gen = mog.opt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.opt.gen:SetPoint("TOPLEFT",mog.opt,"TOPLEFT",5,-5);
mog.opt.gen:SetText("General");

mog.opt.mm = CreateFrame("CheckButton","MogItFrameMinimap",mog.opt,"UICheckButtonTemplate");
MogItFrameMinimapText:SetText("Hide Minimap Button");
mog.opt.mm:SetPoint("TOPLEFT",mog.opt.gen,"BOTTOMLEFT",0,0);
mog.opt.mm:SetScript("OnClick",function(self)
	if self:GetChecked() then
		mog.LDBI:Hide(MogIt);
	else
		mog.LDBI:Show(MogIt);
	end
end);

mog.opt.cat = mog.opt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.opt.cat:SetPoint("TOPLEFT",mog.opt.mm,"BOTTOMLEFT",0,-15);
mog.opt.cat:SetText("Catalogue");

mog.opt.cnaked = CreateFrame("CheckButton","MogItFrameCNaked",mog.opt,"UICheckButtonTemplate");
MogItFrameCNakedText:SetText("Naked models");
mog.opt.cnaked:SetPoint("TOPLEFT",mog.opt.cat,"BOTTOMLEFT",0,0);
mog.opt.cnaked:SetScript("OnClick",function(self)
	mog.settings.guiDress = not self:GetChecked();
	if mog.grid:IsShown() then
		mog.scroll:update();
	end
end);

mog.opt.addrows = CreateFrame("Button","MogItOptionsAddRows",mog.opt,"UIPanelButtonTemplate2");
mog.opt.addrows:SetText("+");
mog.opt.addrows:SetWidth(22);
mog.opt.addrows:SetHeight(22);
mog.opt.addrows:SetPoint("TOPLEFT",mog.opt.cnaked,"BOTTOMLEFT",0,-3);
mog.opt.addrows:SetScript("OnClick",function(self)
	local m = ((mog.settings.rows + 1) * mog.settings.guiHeight) + (mog.settings.rows * 5) + 20 + 20;
	if m <= GetScreenHeight() then
		mog.settings.rows = mog.settings.rows + 1;
		mog.updateGUI();
		if mog.grid:IsShown() then
			mog.scroll:update();
		end
	end
end);

mog.opt.delrows = CreateFrame("Button","MogItOptionsDelRows",mog.opt,"UIPanelButtonTemplate2");
mog.opt.delrows:SetText("-");
mog.opt.delrows:SetWidth(22);
mog.opt.delrows:SetHeight(22);
mog.opt.delrows:SetPoint("TOPLEFT",mog.opt.addrows,"TOPRIGHT",0,0);
mog.opt.delrows:SetScript("OnClick",function(self)
	mog.settings.rows = (mog.settings.rows > 1 and mog.settings.rows - 1) or 1;
	mog.updateGUI();
	if mog.grid:IsShown() then
		mog.scroll:update();
	end
end);

mog.opt.rows = mog.opt:CreateFontString(nil,"ARTWORK","GameFontNormalSmall");
mog.opt.rows:SetPoint("TOPLEFT",mog.opt.delrows,"TOPRIGHT",3,-8);
mog.opt.rows:SetText("Rows");

mog.opt.addcolumns = CreateFrame("Button","MogItOptionsAddColumns",mog.opt,"UIPanelButtonTemplate2");
mog.opt.addcolumns:SetText("+");
mog.opt.addcolumns:SetWidth(22);
mog.opt.addcolumns:SetHeight(22);
mog.opt.addcolumns:SetPoint("TOPLEFT",mog.opt.addrows,"BOTTOMLEFT",0,-3);
mog.opt.addcolumns:SetScript("OnClick",function(self)
	local m = ((mog.settings.columns + 1) * mog.settings.guiWidth) + (mog.settings.columns * 5) + 20 + 43;
	if m <= GetScreenWidth() then
		mog.settings.columns = mog.settings.columns + 1;
		mog.updateGUI();
		if mog.grid:IsShown() then
			mog.scroll:update();
		end
	end
end);

mog.opt.delcolumns = CreateFrame("Button","MogItOptionsDelColumns",mog.opt,"UIPanelButtonTemplate2");
mog.opt.delcolumns:SetText("-");
mog.opt.delcolumns:SetWidth(22);
mog.opt.delcolumns:SetHeight(22);
mog.opt.delcolumns:SetPoint("TOPLEFT",mog.opt.addcolumns,"TOPRIGHT",0,0);
mog.opt.delcolumns:SetScript("OnClick",function(self)
	mog.settings.columns = (mog.settings.columns > 1 and mog.settings.columns - 1) or 1;
	mog.updateGUI();
	if mog.grid:IsShown() then
		mog.scroll:update();
	end
end);

mog.opt.columns = mog.opt:CreateFontString(nil,"ARTWORK","GameFontNormalSmall");
mog.opt.columns:SetPoint("TOPLEFT",mog.opt.delcolumns,"TOPRIGHT",3,-8);
mog.opt.columns:SetText("Columns");

mog.opt.tt = mog.opt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.opt.tt:SetPoint("TOPLEFT",mog.opt.addcolumns,"BOTTOMLEFT",0,-18);
mog.opt.tt:SetText("Tooltip");

mog.opt.tooltip = CreateFrame("CheckButton","MogItFrameTooltip",mog.opt,"UICheckButtonTemplate");
MogItFrameTooltipText:SetText("Enable tooltip model");
mog.opt.tooltip:SetPoint("TOPLEFT",mog.opt.tt,"BOTTOMLEFT",0,0);
mog.opt.tooltip:SetScript("OnClick",function(self)
	mog.settings.tt = self:GetChecked();
end);

mog.opt.tnaked = CreateFrame("CheckButton","MogItFrameTNaked",mog.opt,"UICheckButtonTemplate");
MogItFrameTNakedText:SetText("Naked model");
mog.opt.tnaked:SetPoint("TOPLEFT",mog.opt.tooltip,"BOTTOMLEFT",0,0);
mog.opt.tnaked:SetScript("OnClick",function(self)
	mog.settings.ttDress = not self:GetChecked();
end);

mog.opt.mouse = CreateFrame("CheckButton","MogItFrameMouse",mog.opt,"UICheckButtonTemplate");
MogItFrameMouseText:SetText("Rotate with mouse wheel");
mog.opt.mouse:SetPoint("TOPLEFT",mog.opt.tnaked,"BOTTOMLEFT",0,0);
mog.opt.mouse:SetScript("OnClick",function(self)
	mog.settings.mouse = self:GetChecked();
end);

mog.opt.auto = CreateFrame("CheckButton","MogItFrameAuto",mog.opt,"UICheckButtonTemplate");
MogItFrameAutoText:SetText("Auto rotate");
mog.opt.auto:SetPoint("TOPLEFT",mog.opt.mouse,"BOTTOMLEFT",0,0);
mog.opt.auto:SetScript("OnClick",function(self)
	mog.settings.rotate = self:GetChecked();
	if mog.settings.rotate then
		mog.tooltip.rotate:Show();
	else
		mog.tooltip.rotate:Hide();
	end
end);

mog.opt.mog = CreateFrame("CheckButton","MogItFrameMog",mog.opt,"UICheckButtonTemplate");
MogItFrameMogText:SetText("Only uncommon/rare/epic");
mog.opt.mog:SetPoint("TOPLEFT",mog.opt.auto,"BOTTOMLEFT",0,0);
mog.opt.mog:SetScript("OnClick",function(self)
	mog.settings.mog = self:GetChecked();
end);

mog.opt.defaults = CreateFrame("Button",nil,mog.optscroll,"UIPanelButtonTemplate");
mog.opt.defaults:SetText(DEFAULTS);
mog.opt.defaults:SetWidth(65);
mog.opt.defaults:SetHeight(22);
mog.opt.defaults:SetPoint("TOPLEFT",mog.frame.Inset,"BOTTOMLEFT");
mog.opt.defaults:SetScript("OnClick",function(self,btn)
	mog.settings.minimap.hide = false;
	mog.settings.guiDress = false;
	mog.settings.tt = true;
	mog.settings.ttDress = false;
	mog.settings.mouse = true;
	mog.settings.rotate = true;
	mog.settings.mog = true;
	mog.opt.update();
end);

function mog.opt.update()
	mog.opt.mm:SetChecked(mog.settings.minimap.hide);
	mog.opt.cnaked:SetChecked(not mog.settings.guiDress);
	mog.opt.tooltip:SetChecked(mog.settings.tt);
	mog.opt.tnaked:SetChecked(not mog.settings.ttDress);
	mog.opt.mouse:SetChecked(mog.settings.mouse);
	mog.opt.auto:SetChecked(mog.settings.rotate);
	mog.opt.mog:SetChecked(mog.settings.mog);
end